package org.adtpro.gui.AudioConfig;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.SourceDataLine;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.Mixer.Info;

import org.adtpro.resources.Messages;

public class Output extends Abstract {
    private static final long serialVersionUID = 1L;
    
    protected static Abstract _theSingleton = null;

    /**
     * Retrieve the single instance of this class.
     * 
     * @return Log
     */
    public static Abstract getSingleton()
    {
      if (null == _theSingleton)
    	  _theSingleton = allocateSingleton();
      return _theSingleton;
    }

	protected Output() {
		super();
	}

	protected String getPropertyNameForPort() {
		return "AudioOutputPortIndex"; //$NON-NLS-1$
	}
	
	protected boolean isAcceptable(final Info info) {
		boolean result = true; 
		try {
			final AudioFormat audioFormat = Abstract.getAudioFormat();
			final DataLine.Info dataLineInfo = new DataLine.Info(SourceDataLine.class, audioFormat);
			final Mixer mixer = AudioSystem.getMixer(info);
			final DataLine dataLine = (SourceDataLine) mixer.getLine(dataLineInfo);
			try {
				dataLine.open();
			} finally {
				dataLine.close();
			}
		} catch (Exception e) {
			result = false;
		}
		return result;
	}
	
	protected String getDialogTitle() {
		return Messages.getString("Gui.AudioConfig.Output.DialogTitle"); //$NON-NLS-1$
	}
	
	protected Abstract getInstance() {
		return _theSingleton;
	}

	public String getMenuItem() {
		return Messages.getString("Gui.AudioConfig.Output.MenuItem"); //$NON-NLS-1$
	}
}
